package cokr.xit.fims.rcvm.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.rcvm.Rcvmt;
import cokr.xit.fims.rcvm.RcvmQuery;

/** 수납 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-31	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("rcvmtMapper")
public interface RcvmtMapper extends AbstractMapper {

	/**지정한 조건에 따라 수납 대장 목록을 조회하여 반환한다.<br />
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 목록
	 */
	List<DataObject> selectRcvmtList(RcvmQuery req);

	/**지정한 조건에 따라 수납 대장 객체들을 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 객체 목록
	 */
	List<DataObject> selectRcvmts(RcvmQuery req);

	/**지정한 수납 ID에 따라 수납 대장 객체를 반환한다.
	 * @param rcvmtId 수납 ID
	 * @return 수납 대장 객체
	 */
	default DataObject selectRcvmtInfo(RcvmQuery req) {
		List<DataObject> rcvmts = selectRcvmts(req);

		return !rcvmts.isEmpty() ? rcvmts.get(0) : null;
	}

	/**수납 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertRcvmt(Map<String, Object> params);

	/**수납 대장 정보를 등록한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Rcvmt rcvmt) {
		return rcvmt != null && insertRcvmt(params().set("rcvmt", rcvmt)) == 1;
	}

	/**수납 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateRcvmt(Map<String, Object> params);

	/**수납 대장 정보를 수정한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Rcvmt rcvmt) {
		return rcvmt != null && updateRcvmt(params().set("rcvmt", rcvmt)) == 1;
	}

	/**지정한 수납 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteRcvmt(Map<String, ?> params);

	/**수납 대장 정보를 삭제한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Rcvmt rcvmt) {
		return rcvmt != null && deleteRcvmt(params().set("rcvmt", rcvmt)) == 1;
	}

}
